function FSLH = func_FSLH(N,q)
%%  sliced Latin hypercube designs with slices of arbitrary run sizes
% Email: zhangjing_nudt@163.com
% N =[n1,n2,...,nu]  % denotes the size of all slices
% q                  % denotes the dimension
%% Initialize
u = length(N);
N_sum=  zeros(1,u+1);
for i = 2:u+1
    N_sum(i) = N_sum(i-1)+N(i-1);
end
n = N_sum(u+1);
% The lcm for n_1,n_2,...,n_u,sum(n_1,n_2,...,n_u)
L = 1;
for i = 1:u
    L = lcm(L,N(i));
end
L = lcm(L,n);
%% the matrix which denotes whether a slice jumps at a integer
Pos = zeros(n,u);   % the element  of Pos is 0 or 1, Pos(i,j) = 1 denotes that the i slice jumps at j.
for i = 1:u
    for r = 1:n
         Pos(r,i) = ceil(N(i)*(r+1)/n)-ceil(N(i)*r/n); 
    end
end
%%
h_cell =cell(1,u); 
Set = [];   
firstpoint_jumped = ones(1,u);        % it denots that the smallest integer which can be choosen from Set.
for r = 1:n
    Set = [Set,r];                                 % Put the element into the Set
    index_add = find(Pos(r,1:u)==1);   % find out which slice jumps at r
    len_index = length(index_add);
    for j = 1:len_index
        for i = 1:length(Set)
            if Set(i) >= firstpoint_jumped(index_add(j))
                outpoint = Set(i);
                Set(i)=[];
                break
            end
        end            
        firstpoint_jumped(index_add(j)) = r+1;
        h_cell{index_add(j)} = [h_cell{index_add(j)},outpoint];
    end        
end
%% Unrandomly Permutate
HH = zeros(n,q);
for oo = 1:q
    for i = 1:u
        tt = randperm(N(i));
        HH(N_sum(i)+1:N_sum(i+1),oo) = (h_cell{i}(tt));
    end
end
FSLH = (HH*L/n);
% FSLHD = (HH*L/n - random(n,q))./L; % normalization

