function FSLH_best = func_Outer_Loop(FSLH_0,N,T_h0,P,m,t,tol,beta,opt_slice,L,R)
%% Outer_Loop  
%% Email zhangjing_nudt@163.com
% FSLH_0                  % initial  FSLH
% N=[n_1,n_2,...,n_t]  %  denotes the size of all slices
% T_h0 = 0.1             %  initial acceptable threshold
% P                           % The number of upmost column operation  we set M to be 2nlm/J but no larger than 100.
% m = 2                    % variable parameter for Phi_t value
% t = 50                    % variable parameter for Phi_t value
% tol = 0.1      
% beta = [0.8,0.7,0.9]
% opt_slice =opt_slice  % optimized  slice
%  L                            % The lcm for n_1,n_2,...,n_u,sum(n_1,n_2,...,n_u)
% R = R                      % The position of the first point in each slice
%%
FSLH = FSLH_0;
FSLH_best = FSLH;
T_h = T_h0;
%% The maximum  number of cycles is used as the stopping criterion
for j = 1:10          % The convergence criteria. let 10
    FSLHD_old_best = FSLH_best;
    n_ac = 0;
    n_im = 0;
    FSLH_best   =  func_Inner_Loop(FSLH_best,FSLH,N,P,m,t,T_h,L,opt_slice,R);
    if  func_Phi_CSM( FSLHD_old_best,N,R,L,m,t) -func_Phi_CSM(FSLH_best,N,R,L,m,t) > tol      % tolerance =0.1
        flag_imp = 1;
    else
        flag_imp = 0;
    end
    %% The improvement process
    if flag_imp == 1
        if n_ac/P >= 0.1 && n_im/P < n_ac/P
            T_h = beta(1)*T_h;
        else
            if n_ac/P>=0.1 && n_im/P == n_ac/P
                T_h = T_h;
            else
                T_h = T_h/beta(1); % beta(1)=0.8
            end
        end
        %%  In the exploration process
    else
        if n_ac/P < 0.1
            T_h = T_h/beta(2); % beta(2) =0.7
        else
            T_h = T_h*beta(3); % beta(3)=0.9
        end
    end
end