function Phi_CSM_best = func_SESE(N,q,T_h0,P,m,t,tol,beta)
%%  SESE algorithm
%% Email zhangjing_nudt@163.com
% FSLH_0 = func_FSLH(N,q);
% N=[n_1,n_2,...,n_t]   % denotes the size of all slices
% T_h0 = 0.1            % the value to control the optimization, acceptable threshold 
% P                     % The number of upmost column operation  we set M to be 2nlm/J but no larger than 100.
% m = 2                 % variable parameter for Phi_t value
% t = 50                % variable parameter for Phi_t value
% tol = 0.1                  
% beta = [0.8,0.7,0.9]
FSLH_0 = func_FSLH(N,q);
u = length(N);     % the number of slices
n = sum(N);        % all  points of the design
%% The LCM for the n_1,n_2,...,n_t,n
L = 1;
for i = 1:u
  L = lcm(L,N(i));
end
L = lcm(L,n);
%% The position of the first point in each slice
R = N(1);
for j = 1:length(N)-1  
    R = [R,R(j)+N(j+1)]; 
end   
R = [0,R];
% Phi_CSM_0 = func_Phi_CSM(FSLH_0,N,R,L,m,t); % Initial func_Phi_CSM_value
%% SESE
FSLH_best = FSLH_0;
for  opt_slice = 1:u
  FSLH_0  =  FSLH_best;
  FSLH_best = func_Outer_Loop(FSLH_0,N,T_h0,P,m,t,tol,beta,opt_slice,L,R);
end
Phi_CSM_best = func_Phi_CSM(FSLH_best,N,R,L,m,t);

