function  Phi_CSM_best = func_Optimal_I(N,P,m,t,q)
%% Part-I
% Email zhangjing_nudt@163.com
% N=[n_1,n_2,...,n_t]      %denotes the size of all slices
% P = 100;                % iteration
% m = 2                    % variable parameter for Phi_t value
% t = 50                   % variable parameter for Phi_t value
% q = 2;                   % dimension of the design.
%%
u = length(N);  %  the number of slices
n = sum(N);     %  all design points
%% The lcm for n_1,n_2,...,n_t,n
L = 1;
for i = 1:u
    L = lcm(L,N(i));
end
L = lcm(L,n);
t_a = L./N;
%%  The position of the first point in each slice
R = N(1);
for k = 1:u-1
    R = [R,R(k)+N(k+1)];
end
R = [0,R];
%% Part-I algorithm
FSLH_0 = func_FSLH(N,q);
FSLH = FSLH_0;
for j = 1:length(N)
    if fun_duplicate(ceil(FSLH./t_a(j)))==0
        for k = 1:P                                              % iteration = 1000
            col =  randperm(q,1);
            FSLH_N = func_slice_in(FSLH,N,col,j);  % a neighbor of an FSLH
            if  fun_duplicate(ceil(FSLH_N./t_a(j)))==0
                Phi_CSM_N = func_Phi_CSM(FSLH_N,N,R,L,m,t);
                Phi_CSM   = func_Phi_CSM(FSLH,N,R,L,m,t);
                if Phi_CSM_N <  Phi_CSM
                    FSLH = FSLH_N;
                end
            end
        end
    else
        if N(j)^q > sum(N)
            for l =1:P
                dis_matrix =  func_dis(ceil( FSLH./t_a(j)),2);
                dis_mat_1 = dis_matrix + eye(n);    % eye(n): n*n unnit diagonal matrix
                for pp = 1:u   
                    [ duplicate_row,~] = (find(dis_mat_1(R(pp)+1:R(pp+1),:)==0)); 
                    if length(duplicate_row)~= 0               
                        duplicate_row = duplicate_row + R(pp); 
                        col =  randperm(q,1);    % the exchange column
                        pp_duplicate_row = duplicate_row( randperm(length(duplicate_row),1))  ;
                        A = setdiff(R(pp)+1:R(pp+1),pp_duplicate_row);
                        pp_exchange_row = A(randperm(length(A),1));
                        FSLH_new = FSLH;
                        FSLH_new(pp_duplicate_row,col) =  FSLH(pp_exchange_row,col);
                        FSLH_new(pp_exchange_row,col)  =  FSLH(pp_duplicate_row,col);
                        FSLH = FSLH_new;
                        if  fun_duplicate(ceil(FSLH_new./t_a(j)))==0
                            break
                        end
                    end
                end
                if  fun_duplicate(ceil(FSLH./t_a(j)))==0
                    break
                end
            end
        end
    end
    %% within-slice exchange procedure
    for k = 1:P
        col =  randperm(q,1);
        FSLH_N = func_slice_in(FSLH,N,col,j);   % a neighbor of the FSLH
        if  fun_duplicate(ceil(FSLH_N./t_a(j)))==0
            Phi_CSM_N = func_Phi_CSM(FSLH_N,N,R,L,m,t);
            Phi_CSM = func_Phi_CSM(FSLH,N,R,L,m,t);
            if Phi_CSM_N <  Phi_CSM
                FSLH = FSLH_N;
            end
        end
    end
end
Phi_CSM_best = func_Phi_CSM(FSLH,N,R,L,m,t);
%%  initial  Phi_CSM_0 for conparison
% Phi_CSM_0 = func_Phi_CSM(FSLH_0,N,R,L,m,t);
























