function  FSLH_best = func_Inner_Loop(FSLH_best,FSLH,N,P,m,t,T_h,L,opt_slice,R)
%% Inner_Loop
%% Email zhangjing_nudt @163.com
% N=[n_1,n_2,...,n_t]  % denotes the size of all slices
% P                           % The number of upmost column operation  we set M to be 2nlm/J but no larger than 100.
% m = 2                    % variable parameter for Phi_t value
% t = 50                    % variable parameter for Phi_t value
% T_h                        %  acceptable threshold ,the value to control the optimization,  
% beta = [0.8,0.7,0.9]
%  L                            % The lcm for n_1,n_2,...,n_u,sum(n_1,n_2,...,n_u)
% opt_slice =opt_slice % optimized  slice
% R = R                      % The position of the first point in each slice
%% The number of upmost column operation
n_ac = 0;
n_im = 0;
q = size(FSLH,2);                    
for k = 1:P                             
    select_column = mod(k,q)+1;                                                                    % The operating column
    in_column_set   = func_in_column(FSLH,select_column,N,opt_slice);           % The within-slice exchange
    bet_column_set = func_bet_column(FSLH,select_column,N,opt_slice,L,R);   % The different-slice exchange and out-slice exchange.
    column_exchange_all = [in_column_set,bet_column_set];                           % comebine 
    column_num = size(column_exchange_all,2);                                             % The all colmuns of the column_exchange_all
    %%   Select the best  FSLH_N
    Phi_CSM = zeros(1,column_num);
    for j = 1:column_num
        FSLH_N_prep = FSLH;
        FSLH_N_prep(:,select_column) = column_exchange_all(:,j);
        t_value_N_prep =func_Phi_CSM(FSLH_N_prep,N,R,L,m,t);
        Phi_CSM(j) = t_value_N_prep;     % All FSLH_N_prep's  Phi_CSM
    end
    Phi_CSM_best = min(min(Phi_CSM));                                          %  It is possible to get more than one samllest Phi_CSM_better
    Phi_CSM_best_index = min(find(Phi_CSM == Phi_CSM_best));    
    %%
    FSLH_N = FSLH;
    FSLH_N(:,select_column) = column_exchange_all(:,Phi_CSM_best_index); 
    if Phi_CSM(Phi_CSM_best_index) -func_Phi_CSM(FSLH,N,R,L,m,t) <= T_h*rand(1) 
        FSLH =  FSLH_N;
        n_ac = n_ac+1;
        if func_Phi_CSM(FSLH,N,R,L,m,t) <func_Phi_CSM(FSLH_best,N,R,L,m,t)
            FSLH_best = FSLH;
            n_im = n_im+1;
        end
    end
end

