function  Phi_CSM_best = func_Optimal_II(N,P,m,t,q)
%% Part I+Part II 
% Email zhangjing_nudt@163.com
u = length(N);  %  the number of slices
n = sum(N);     %  all design points
%% The lcm for n_1,n_2,...,n_t,n
L = 1;
for i = 1:u
    L = lcm(L,N(i));
end
L = lcm(L,n);
t_a = L./N;
%%  The position of the first point in each slice
R = N(1);
for k = 1:u-1
    R = [R,R(k)+N(k+1)];
end
R = [0,R];
%% Part-I algorithm
FSLH_0 = func_FSLH(N,q);
FSLH = FSLH_0;
for j = 1:length(N)
    if fun_duplicate(ceil(FSLH./t_a(j)))==0
        for k = 1:P                                  
            col =  randperm(q,1);
            FSLH_N = func_slice_in(FSLH,N,col,j);     % a neighbor FSLH
            if  fun_duplicate(ceil(FSLH_N./t_a(j)))==0
                if func_Phi_CSM(FSLH_N,N,R,L,m,t) < func_Phi_CSM(FSLH,N,R,L,m,t)
                    FSLH = FSLH_N;
                end
            end
        end
    else
        if N(j)^q > sum(N)
            for l =1:P
                dis_matrix =  func_dis(ceil( FSLH./t_a(j)),2);
                dis_mat_1 = dis_matrix + eye(n);    
                for pp = 1:u
                    [ duplicate_row,~] = (find(dis_mat_1(R(pp)+1:R(pp+1),:)==0)); 
                    if length(duplicate_row)~= 0               
                        duplicate_row = duplicate_row + R(pp); 
                        col =  randperm(q,1);    % the exchange column
                        pp_duplicate_row = duplicate_row( randperm(length(duplicate_row),1))  ;
                        A = setdiff(R(pp)+1:R(pp+1),pp_duplicate_row);
                        pp_exchange_row = A(randperm(length(A),1));
                        FSLH_new = FSLH;
                        FSLH_new(pp_duplicate_row,col) =  FSLH(pp_exchange_row,col);
                        FSLH_new(pp_exchange_row,col)  =  FSLH(pp_duplicate_row,col);
                        FSLH = FSLH_new;
                        if  fun_duplicate(ceil(FSLH_new./t_a(j)))==0
                            break
                        end
                    end
                end
                if  fun_duplicate(ceil(FSLH./t_a(j)))==0
                    break
                end
            end
        end
    end
    %% within-slice exchange procedure
    for k = 1:P
        col =  randperm(q,1);
        FSLH_N = func_slice_in(FSLH,N,col,j);   
        if  fun_duplicate(ceil(FSLH_N./t_a(j)))==0
            if func_Phi_CSM(FSLH_N,N,R,L,m,t) <  func_Phi_CSM(FSLH,N,R,L,m,t)
                FSLH = FSLH_N;
            end
        end
    end
end
%% Part-II algorithm
%% different-slice  exchange procedure and  out-slice exchange procedure
for jj = 1:length(N)
    for k = 1:100
        col =  randperm(q,1);
        num = N(jj);
        r_index = randperm(num,1)+ R(jj);               % one random position of the jjth slice
        one_element = FSLH(r_index,col);                % one random element of the jjth slice
        t_e = L./N(jj);                                 % t value of jjth slice
        index = ceil(one_element/t_e);
        domain_bet = (index-1)*t_e+1:(index*t_e);       % domain of the candidate elements.
        candi_bet = setdiff(domain_bet,one_element);    % delete one_element of the   domain_bet
        valid_set = func_valid_set(candi_bet,FSLH(:,col),one_element,N,jj,L,R);
        FSLH_col_w = setdiff(1:L,FSLH(:,col)');
        FSLH_col_w_all = [FSLH(:,col)',FSLH_col_w];
        FSLH_N = FSLH;
        if length(valid_set)==0
            FSLH = FSLH_N;
        else
            exchange = valid_set(randperm(length(valid_set),1));
            s_index = find(FSLH_col_w_all == exchange);  % the position of the design
            if  s_index  <= sum(N)                       % different_slice exchang procedure
                FSLH_N(r_index,col) = FSLH(s_index ,col);
                FSLH_N(s_index ,col) = FSLH(r_index,col);
                if  fun_duplicate(ceil(FSLH_N./t_a(jj)))== 0
                    if  func_Phi_CSM(FSLH_N,N,R,L,m,t) < func_Phi_CSM(FSLH,N,R,L,m,t)
                        FSLH = FSLH_N;
                    end
                end
            else
                FSLH_N(r_index,col) = exchange;                  % out slice exchange  procedure
                if  fun_duplicate(ceil(FSLH_N./t_a(jj)))==0 
                    if func_Phi_CSM(FSLH_N,N,R,L,m,t) < func_Phi_CSM(FSLH,N,R,L,m,t)
                        FSLH = FSLH_N;
                    end
                end
            end
        end
    end
end
Phi_CSM_best = func_Phi_CSM(FSLH,N,R,L,m,t);
%%  initial Phi_CSM for conparison
% Phi_CSM_0 = func_Phi_CSM(FSLH_0,N,R,L,m,t);

























